ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.14 by root, Fri Dec 10 20:29:17 2010 UTC vs.
Revision 1.43 by root, Tue May 10 17:40:17 2011 UTC

5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10
11# perl build variables 10# perl build variables
11MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc
13PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
14PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
15PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
16 17
17ARCH="$(uname -m)" 18ARCH="$(uname -m)"
18 19
19case "$ARCH" in 20case "$ARCH" in
27 ;; 28 ;;
28esac 29esac
29 30
30# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
31# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
32# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
33PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
34PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
35 37
36# some configuration options for modules 38# some configuration options for modules
37export PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
38#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
39export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
40 44
41# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
42# required by mkbundle 46# required by mkbundle
43STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
44 48
45# which extra modules you might want to install 49# which extra modules you might want to install
46EXTRA_MODULES="" 50EXTRA_MODULES=""
47 51
48# overridable functions 52# overridable functions
49preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
50postconfigure() { : ; } 55postconfigure() { : ; }
51postbuild() { : ; } 56postbuild() { : ; }
52postinstall() { : ; } 57postinstall() { : ; }
53 58
54# now source user config, if any 59# now source user config, if any
61fi 66fi
62 67
63############################################################################# 68#############################################################################
64# support 69# support
65 70
66MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
67PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
68 72
69unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
70export LC_ALL=C # just to be on the safe side 75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
71 80
72# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
73VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
74$VERSION=0.9 83$VERSION="1.3"
75 84
76BZ2=bz2 85BZ2=bz2
77BZIP2=bzip2 86BZIP2=bzip2
78 87
79fatal() { 88fatal() {
125 134
126clean() { 135clean() {
127 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 136 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
128} 137}
129 138
139realclean() {
140 rm -f "$PERL_PREFIX/staticstamp.postinstall"
141 rm -f "$PERL_PREFIX/staticstamp.install"
142 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
143}
144
130fetch() { 145fetch() {
131 rcd "$STATICPERL" 146 rcd "$STATICPERL"
132 147
133 mkdir -p src 148 mkdir -p src
134 rcd src 149 rcd src
141 verblock <<EOF 156 verblock <<EOF
142downloading perl 157downloading perl
143to manually download perl yourself, place 158to manually download perl yourself, place
144perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
145trying $URL 160trying $URL
161
162either curl or wget is required for automatic download.
163curl is tried first, then wget.
146EOF 164EOF
147 165
148 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 166 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
167 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
149 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 168 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
150 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
151 || fatal "$URL: unable to download" 169 || fatal "$URL: unable to download"
170 rm -f perl-$PERL_VERSION.tar.$BZ2
152 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 171 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
153 fi 172 fi
154 173
155 verblock <<EOF 174 verblock <<EOF
156unpacking perl 175unpacking perl
157EOF 176EOF
158 177
159 mkdir -p unpack 178 mkdir -p unpack
179 rm -rf unpack/perl-$PERL_VERSION
160 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 180 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
161 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 181 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
162 chmod -R u+w unpack/perl-$PERL_VERSION 182 chmod -R u+w unpack/perl-$PERL_VERSION
163 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 183 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
164 rmdir -p unpack 184 rmdir -p unpack
165 fi 185 fi
166} 186}
167 187
168# similar to GNU-sed -i or perl -pi 188# similar to GNU-sed -i or perl -pi
169sedreplace() { 189sedreplace() {
170 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 190 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
191 rm -f "$2"
171 mv "$2~" "$2" 192 mv "$2~" "$2"
193}
194
195configure_failure() {
196 cat <<EOF
197
198
199***
200*** Configure failed - see above for the exact error message(s).
201***
202*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
203*** flags are not supported by your compiler. Less often, this is because
204*** PERL_LIBS either contains a library not available on your system (such as
205*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
206***
207*** You can provide your own flags by creating a ~/.staticperlrc file with
208*** variable assignments. For example (these are the actual values used):
209***
210
211PERL_CC="$PERL_CC"
212PERL_CCFLAGS="$PERL_CCFLAGS"
213PERL_OPTIMIZE="$PERL_OPTIMIZE"
214PERL_LDFLAGS="$PERL_LDFLAGS"
215PERL_LIBS="$PERL_LIBS"
216
217EOF
218 exit 1
172} 219}
173 220
174configure() { 221configure() {
175 fetch 222 fetch
176 223
182configuring $STATICPERL/src/perl-$PERL_VERSION 229configuring $STATICPERL/src/perl-$PERL_VERSION
183EOF 230EOF
184 231
185 rm -f "$PERL_PREFIX/staticstamp.install" 232 rm -f "$PERL_PREFIX/staticstamp.install"
186 233
187 make distclean >/dev/null 2>&1 234 "$MAKE" distclean >/dev/null 2>&1
188 235
236 sedreplace '/^#define SITELIB/d' config_h.SH
237
189 # I hate them 238 # I hate them for this
190 grep -q -- -fstack-protector Configure && \ 239 grep -q -- -fstack-protector Configure && \
191 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 240 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
192 241
193 preconfigure 242 # what did that bloke think
243 grep -q -- usedl=.define hints/darwin.sh && \
244 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
245
246 preconfigure || fatal "preconfigure hook failed"
194 247
195# trace configure \ 248# trace configure \
196 sh Configure -Duselargefiles \ 249 sh Configure -Duselargefiles \
197 -Uuse64bitint \ 250 -Uuse64bitint \
198 -Dusemymalloc=n \ 251 -Dusemymalloc=n \
199 -Uusedl \ 252 -Uusedl \
200 -Uusethreads \ 253 -Uusethreads \
201 -Uuseithreads \ 254 -Uuseithreads \
202 -Uusemultiplicity \ 255 -Uusemultiplicity \
203 -Duseperlio \
204 -Uusesfio \ 256 -Uusesfio \
205 -Uuseshrplib \ 257 -Uuseshrplib \
258 -Uinstallusrbinperl \
206 -Dcppflags="$PERL_CPPFLAGS" \ 259 -A ccflags=" $PERL_CCFLAGS" \
207 -Dccflags="-g2 -fno-strict-aliasing" \ 260 -Dcc="$PERL_CC" \
208 -Doptimize="$PERL_OPTIMIZE" \ 261 -Doptimize="$PERL_OPTIMIZE" \
209 -Dldflags="$PERL_LDFLAGS" \ 262 -Dldflags="$PERL_LDFLAGS" \
210 -Dlibs="$PERL_LIBS" \ 263 -Dlibs="$PERL_LIBS" \
211 -Dprefix="$PERL_PREFIX" \ 264 -Dprefix="$PERL_PREFIX" \
212 -Dbin="$PERL_PREFIX/bin" \ 265 -Dbin="$PERL_PREFIX/bin" \
213 -Dprivlib="$PERL_PREFIX/lib" \ 266 -Dprivlib="$PERL_PREFIX/lib" \
214 -Darchlib="$PERL_PREFIX/lib" \ 267 -Darchlib="$PERL_PREFIX/lib" \
215 -Uusevendorprefix \ 268 -Uusevendorprefix \
216 -Dsitelib="$PERL_PREFIX/lib" \ 269 -Dsitelib="$PERL_PREFIX/lib" \
217 -Dsitearch="$PERL_PREFIX/lib" \ 270 -Dsitearch="$PERL_PREFIX/lib" \
218 -Usitelibexp \
219 -Uman1dir \ 271 -Uman1dir \
220 -Uman3dir \ 272 -Uman3dir \
221 -Usiteman1dir \ 273 -Usiteman1dir \
222 -Usiteman3dir \ 274 -Usiteman3dir \
223 -Dpager=/usr/bin/less \ 275 -Dpager=/usr/bin/less \
224 -Demail="$EMAIL" \ 276 -Demail="$EMAIL" \
225 -Dcf_email="$EMAIL" \ 277 -Dcf_email="$EMAIL" \
226 -Dcf_by="$EMAIL" \ 278 -Dcf_by="$EMAIL" \
227 $PERL_CONFIGURE \ 279 $PERL_CONFIGURE \
280 -Duseperlio \
228 -dE || fatal "Configure failed" 281 -dE || configure_failure
229 282
230 sedreplace ' 283 sedreplace '
231 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 284 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
232 s/ *-fno-stack-protector */ /g 285 s/ *-fno-stack-protector */ /g
233 ' config.sh 286 ' config.sh
234 287
288 patchconfig || fatal "patchconfig hook failed"
289
235 sh Configure -S || fatal "Configure -S failed" 290 sh Configure -S || fatal "Configure -S failed"
236 291
237 postconfigure || fatal "postconfigure hook failed" 292 postconfigure || fatal "postconfigure hook failed"
238 293
239 touch staticstamp.configure 294 touch staticstamp.configure
295}
296
297write_shellscript() {
298 {
299 echo "#!/bin/sh"
300 echo "STATICPERL=\"$STATICPERL\""
301 echo "PERL_PREFIX=\"$PERL_PREFIX\""
302 echo "MAKE=\"$MAKE\""
303 cat
304 } >"$PERL_PREFIX/bin/$1"
305 chmod 755 "$PERL_PREFIX/bin/$1"
240} 306}
241 307
242build() { 308build() {
243 configure 309 configure
244 310
248building $STATICPERL/src/perl-$PERL_VERSION 314building $STATICPERL/src/perl-$PERL_VERSION
249EOF 315EOF
250 316
251 rm -f "$PERL_PREFIX/staticstamp.install" 317 rm -f "$PERL_PREFIX/staticstamp.install"
252 318
253 make || fatal "make: error while building perl" 319 "$MAKE" || fatal "make: error while building perl"
254 320
255 postbuild || fatal "postbuild hook failed" 321 postbuild || fatal "postbuild hook failed"
256} 322}
257 323
258install() { 324install() {
265EOF 331EOF
266 332
267 ln -sf "perl/bin/" "$STATICPERL/bin" 333 ln -sf "perl/bin/" "$STATICPERL/bin"
268 ln -sf "perl/lib/" "$STATICPERL/lib" 334 ln -sf "perl/lib/" "$STATICPERL/lib"
269 335
336 mkdir "$STATICPERL/patched"
337
270 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 338 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
271 rm -rf "$PERL_PREFIX" # by this rm -rf 339 rm -rf "$PERL_PREFIX" # by this rm -rf
272 340
273 make install || fatal "make install: error while installing" 341 "$MAKE" install || fatal "make install: error while installing"
274 342
275 rcd "$PERL_PREFIX" 343 rcd "$PERL_PREFIX"
276 344
277 # create a "make install" replacement for CPAN 345 # create a "make install" replacement for CPAN
278 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 346 write_shellscript SP-make-install-make <<'EOF'
279make || exit 347#CAT make-install-make.sh
280
281if find blib/arch/auto -type f | grep -q -v .exists; then
282 echo Probably an XS module, rebuilding perl
283 if make perl; then
284 mv perl "$PERL_PREFIX"/bin/perl
285 make -f Makefile.aperl map_clean
286 else
287 make -f Makefile.aperl map_clean
288 exit 1
289 fi
290fi
291
292make install UNINST=1
293EOF 348EOF
294 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
295 349
350 # create a "patch modules" helper
351 write_shellscript SP-patch-postinstall <<'EOF'
352#CAT patch-postinstall.sh
353EOF
354
355 "$PERL_PREFIX/bin/SP-patch-postinstall"
356
296 # trick CPAN into avoiding ~/.cpan completely 357 # help to trick CPAN into avoiding ~/.cpan completely
297 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 358 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
298 359
360 # we call cpan with -MCPAN::MyConfig in this script, which
361 # is strictly unnecssary as we have to patch CPAN anyway,
362 # so consider it "for good measure".
299 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 363 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
300 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 364 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
301 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 365 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
302 CPAN::Shell->o (conf => q<init>); 366 CPAN::Shell->o (conf => q<init>);
303 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 367 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
304 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 368 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
305 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 369 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
306 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 370 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
307 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 371 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
308 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 372 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
309 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 373 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
310 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 374 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
375 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
311 CPAN::Shell->o (conf => q<commit>); 376 CPAN::Shell->o (conf => q<commit>);
312 ' || fatal "error while initialising CPAN" 377 ' || fatal "error while initialising CPAN"
313 378
314 touch "$PERL_PREFIX/staticstamp.install" 379 touch "$PERL_PREFIX/staticstamp.install"
315 fi 380 fi
335installing modules from CPAN 400installing modules from CPAN
336$@ 401$@
337EOF 402EOF
338 403
339 for mod in "$@"; do 404 for mod in "$@"; do
340 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 405 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
341 || fatal "$mod: unable to install from CPAN" 406 || fatal "$mod: unable to install from CPAN"
342 done 407 done
343 rm -rf "$STATICPERL/build" 408 rm -rf "$STATICPERL/build"
344} 409}
345 410
357 for mod in "$@"; do 422 for mod in "$@"; do
358 echo 423 echo
359 echo $mod 424 echo $mod
360 ( 425 (
361 rcd $mod 426 rcd $mod
362 make -f Makefile.aperl map_clean >/dev/null 2>&1 427 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
363 make distclean >/dev/null 2>&1 428 "$MAKE" distclean >/dev/null 2>&1
364 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 429 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
365 make || fatal "$mod: error building module" 430 "$MAKE" || fatal "$mod: error building module"
366 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 431 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
367 make distclean >/dev/null 2>&1 432 "$MAKE" distclean >/dev/null 2>&1
368 exit 0 433 exit 0
369 ) || exit $? 434 ) || exit $?
370 done 435 done
371} 436}
372 437
373############################################################################# 438#############################################################################
374# main 439# main
375 440
376podusage() { 441podusage() {
377 echo 442 echo
443
378 if [ -e "$PERL_PREFIX/bin/perl" ]; then 444 if [ -e "$PERL_PREFIX/bin/perl" ]; then
379 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 445 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
380 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 446 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
381 2>/dev/null && exit 447 2>/dev/null && exit
382 fi 448 fi
449
383 # try whatever perl we can find 450 # try whatever perl we can find
384 perl -MPod::Usage -e \ 451 perl -MPod::Usage -e \
385 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 452 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
386 2>/dev/null && exit 453 2>/dev/null && exit
387 454
388 fatal "displaying documentation requires a working perl - try '$0 install' first" 455 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
389} 456}
390 457
391usage() { 458usage() {
392 podusage 0 459 podusage 0
393} 460}
401#CAT mkbundle 468#CAT mkbundle
402MKBUNDLE 469MKBUNDLE
403} 470}
404 471
405bundle() { 472bundle() {
473 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
406 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 474 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
407 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 475 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
408 CACHE="$STATICPERL/cache" 476 CACHE="$STATICPERL/cache"
409 mkdir -p "$CACHE" 477 mkdir -p "$CACHE"
410 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 478 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
418 command="${1#--}"; shift 486 command="${1#--}"; shift
419 case "$command" in 487 case "$command" in
420 version ) 488 version )
421 echo "staticperl version $VERSION" 489 echo "staticperl version $VERSION"
422 ;; 490 ;;
423 fetch | configure | build | install | clean | distclean) 491 fetch | configure | build | install | clean | realclean | distclean)
424 ( "$command" ) 492 ( "$command" ) || exit
425 ;; 493 ;;
426 instsrc ) 494 instsrc )
427 ( instsrc "$@" ) 495 ( instsrc "$@" ) || exit
428 exit 496 exit
429 ;; 497 ;;
430 instcpan ) 498 instcpan )
431 ( instcpan "$@" ) 499 ( instcpan "$@" ) || exit
500 exit
501 ;;
502 perl )
503 ( install ) || exit
504 exec "$PERL_PREFIX/bin/perl" "$@"
432 exit 505 exit
433 ;; 506 ;;
434 cpan ) 507 cpan )
435 ( install ) 508 ( install ) || exit
436 "$PERL_PREFIX/bin/cpan" "$@" 509 exec "$PERL_PREFIX/bin/cpan" "$@"
437 exit 510 exit
438 ;; 511 ;;
439 mkbundle ) 512 mkbundle )
440 ( install ) 513 ( install ) || exit
441 bundle "$@" 514 bundle "$@"
442 exit 515 exit
443 ;; 516 ;;
444 mkperl ) 517 mkperl )
445 ( install ) 518 ( install ) || exit
446 bundle --perl "$@" 519 bundle --perl "$@"
447 exit 520 exit
448 ;; 521 ;;
449 mkapp ) 522 mkapp )
450 ( install ) 523 ( install ) || exit
451 bundle --app "$@" 524 bundle --app "$@"
452 exit 525 exit
453 ;; 526 ;;
454 help ) 527 help )
455 podusage 2 528 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines